/**
 *  Copyright (C) 2009 Emerson Ribeiro de Mello, Fernando Fernandes Simão
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2009 Emerson Ribeiro de Mello, Fernando Fernandes Simão
 *
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 */

package objetos;

import abstrata.Personagem;
import java.util.ArrayList;
import java.util.Random;
import javax.swing.JPanel;

public class Chefao extends Personagem {

    private Random r;
    public int vidaChefao;
    private boolean visivel;
    public int velocidadeChefao;
    public ArrayList<CanhaoDePlasma> canhaoChefao1;
    public ArrayList<CanhaoDePlasma> canhaoChefao2;
    public ArrayList<CanhaoDePlasma> canhaoChefao3;

    public Chefao(String nomeImagem, JPanel jp, int px, int py, int velocidade) {
        super(nomeImagem, jp, px, py);
        r = new Random();
        vidaChefao = 500;
        this.visivel = true;
        canhaoChefao1 = new ArrayList<CanhaoDePlasma>();
        canhaoChefao2 = new ArrayList<CanhaoDePlasma>();
        canhaoChefao3 = new ArrayList<CanhaoDePlasma>();
        this.velocidadeChefao = velocidade;

    }

    // retorna o valor da vida do inimigo
    public int obterVidaChefao() {
        return vidaChefao;
    }

    public void movimentarChefao() {
        // movimentaçao horizontal

        int posicaoX = r.nextInt(5);
        boolean increX = r.nextBoolean();
        if (increX == true) {
            if (getX() + getLargura() + posicaoX > tela.getWidth()) {
                setX(tela.getWidth() - getLargura());
            } else {
                incrementaX(posicaoX);
            }
        } else {
            if (getX() - posicaoX > tela.getWidth() / 2) {
                incrementaX(posicaoX * -1);
            } else {
                setX(tela.getWidth() / 2);
            }
        }

        int posicaoY = r.nextInt(3);
        //movimentaçao vertical
        boolean increY = r.nextBoolean();
        if (increY == true) {
            if (getY() + getAltura() + posicaoY < tela.getHeight()) {
                incrementaY(posicaoY);
            } else {
                setY(tela.getHeight() - getAltura());
            }
        } else {
            if (getY() - posicaoY > 0) {
                incrementaY(posicaoY * -1);
            } else {
                setY(0);
            }
        }
    }
}
    





