/**
 *  Copyright (C) 2009 Emerson Ribeiro de Mello, Fernando Fernandes Simão
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (C) 2009 Emerson Ribeiro de Mello, Fernando Fernandes Simão
 *
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 */
package objetos;

import abstrata.Jogador;
import javax.swing.JPanel;
import interfaces.BombaAniquiladora;
import interfaces.EscudoDeForça;
import jogo.Jogo;

public class Puffy extends Jogador implements BombaAniquiladora, EscudoDeForça {

    private Jogo jogo;
    public long tempoInicial;

    public Puffy(String nomeImagem, JPanel jp, int px, int py, Jogo jogo) {
        super("/imagens/puffy.png", jp, px, py);
        this.jogo = jogo;
    }
    // destrói tudo que há na tela que possa causar dano (tiros, inimigos)

    public void ativarBombaAniquiladora() {
        if (this.ativarBombaAniquiladora == false) {
            int poder = new Integer(jogo.jProgressBarPoder.getValue());
            if (poder == 100) {
                this.ativarBombaAniquiladora = true;
                jogo.jProgressBarPoder.setValue(0);
            }
        }
    }
    // cria um escudo temporário que provê imunidade temporária

    public void ativarEscudoDeForca(boolean ativar) {
        if (this.invencibilidade == false) {
            int poder = new Integer(jogo.jProgressBarPoder.getValue());
            if (poder >= 50) {
                this.invencibilidade = true;
                this.alterarImagem("/imagens/puffyescudo.png");
                jogo.jProgressBarPoder.setValue(poder - 50);
            }
        }
    }
}
